.nolist
include \masm32\MasmBasic\MasmBasic.inc	; [url=http://www.masm32.com/board/index.php?topic=12460]download[/url]
; -----------------------------------------------------------------------------------------------------------------------------
DefCon	UseUnicode, 1	; multilingual controls need [url=+2]resources[/url]
DefCon	UseMenu, 1	; put 0 if you don't need the menus
DefCon	UseButton2, 1	; put 0 for no second button
DefCon	MyChoice, 1	; <--- set a UseX number from the list
UseEdit	= 1		; Choose your options, then hit F6
UseListbox	= 2		; to assemble and run this application.
UseNothing	= 0		; Hit Esc or Alt F4 to exit the app.
; -----------------------------------------------------------------------------------------------------------------------------
;  DefCon sets undefined constants:
DefCon AppX,		200		; main window X and Y
DefCon AppY,		200
DefCon AppWidth,		400		; window width and height
DefCon AppHeight,	200
DefCon ButtonWidth,	72		; button sizes in pixels
DefCon ButtonHeight,	24
IdEscape	= VK_ESCAPE		; press Esc to quit your window
IdMenuNew	= 1000			; ID menu item New
IdMenuSave	= 1001			; ID menu item Save
IdMenuCopy	= 1100			; ID menu item Copy
IdMenuEN	= 1101			; ID menu item English
IdMenuRU	= 1102			; ID menu item Russian
IdMenuAR	= 1103			; ID menu item Arabic
IdMenuCH	= 1104			; ID menu item Chinese
IdEdit	= 2000			; depending on MyChoice, either...
IdListbox	= 2000			; ...IdEdit or IdListbox will be used
IdButton1	= 2001
IdButton2	= 2002
IdStatic	= 2003

.data
ClassAppWin	db "MB GUI", 0
ClassButton	db "button", 0
ClassStatic	db "static", 0
DefCon txButton1, "PushMe"
if UseButton2
  if MyChoice eq UseEdit
    DefCon txButton2, "SayHi"
  else
    DefCon txButton2, "Open"
  endif
endif
DefCon txStatic,	"Welcome"
DefCon txApp,	"Multilingual window"
MyAccels	ACCEL <FCONTROL or FVIRTKEY, VK_S, IdMenuSave>
	ACCEL <FVIRTKEY, VK_F5, IdButton1>
	ACCEL <FCONTROL or FVIRTKEY, VK_N, IdMenuNew>
LastAccel	ACCEL <FVIRTKEY, VK_ESCAPE, IdEscape>

.data?
hInstance	HINSTANCE ?
hButton1	HWND ?
hButton2	HWND ?
hStatic	HWND ?
hListbox	equ hEdit			; depending on MyChoice, either...
hEdit	HWND ?			; ...IdEdit or IdListbox will be used
hMainWnd	HWND ?
hMenu	HWND ?
ghM3	HWND ?			; this one global
ghM3PrevCk	DWORD ?			; previously checked language
hButFnt	HWND ?
haccl	HWND ?
opSubClass	DWORD ?
TheLang	DWORD ?

	Init	; initialise [url=http://www.masm32.com/board/index.php?topic=12460]MasmBasic[/url]
WinStart proc
LOCAL wc:WNDCLASSEX
LOCAL msg:MSG
LOCAL hwnd:HWND
	call ClearLocVars
	xor ebx, ebx	; NULL
	wmNull equ <ebx>	; push ebx is shorter than push 0
	mov hInstance, rv(GetModuleHandle, wmNull)
	mov wc.cbSize, SIZEOF WNDCLASSEX
	mov wc.style, CS_HREDRAW or CS_VREDRAW
	mov wc.lpfnWndProc, offset WndProc
;	 mov wc.cbClsExtra, wmNull	not needed, ClearLocVars
;	 mov wc.cbWndExtra, wmNull	has cleared them already
	m2m wc.hInstance, hInstance
	mov wc.hbrBackground, COLOR_BTNFACE+1
	mov wc.lpszClassName, offset ClassAppWin
	mov wc.hIcon, rv(LoadIcon, wc.hInstance, IDI_APPLICATION)
	mov wc.hIconSm, eax
	mov wc.hCursor, rv(LoadCursor, wmNull, IDC_ARROW)
	invoke RegisterClassEx, addr wc
	invoke CreateWindowEx, WS_EX_CLIENTEDGE,
		addr ClassAppWin, addr txApp,
		WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN or WS_VISIBLE,
		AppX, AppY, AppWidth, AppHeight,
		wmNull, wmNull, wc.hInstance, wmNull
	mov hwnd, eax
	mov hMainWnd, eax
	.Repeat
		invoke GetMessage, addr msg, wmNull, wmNull, wmNull
		.Break .if !eax
		invoke TranslateAccelerator, hwnd, haccl, addr msg
		.if !eax
				invoke TranslateMessage, addr msg	; msg not an accelerator
				invoke DispatchMessage, addr msg
		.endif
	.Until 0
	invoke ExitProcess, msg.wParam
WinStart endp

WndProc proc uses ebx hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
LOCAL rc:RECT, hM1:HWND, hM2:HWND
	SWITCH uMsg
	CASE WM_DESTROY
		invoke PostQuitMessage, NULL

	CASE WM_CREATE
		; -------------------- create keyboard shortcuts --------------------------
		@CatStr(<mov haccl, rv(CreateAcceleratorTable, offset MyAccels, >, %dword ptr 1+(LastAccel-MyAccels)/SIZEOF ACCEL,<)>)
		; -------------------- create menus and sub-menus -------------------- 
		if UseMenu
		mov hMenu, rv(CreateMenu)				; create the main menu
		mov hM1, rv(CreateMenu)				; plus three
		mov hM2, rv(CreateMenu)				; sub menus
		mov ghM3, rv(CreateMenu)
		invoke AppendMenu, hMenu, MF_POPUP, hM1, Chr$("&File")
		invoke AppendMenu, hM1, MF_STRING, IdMenuNew, Chr$("&New",9,"Ctrl+N")
		invoke AppendMenu, hM1, MF_STRING, IdMenuSave, Chr$("&Save",9,"Ctrl+S")
		invoke AppendMenu, hMenu, MF_POPUP, hM2, Chr$("&Edit")
		invoke AppendMenu, hM2, MF_STRING, IdMenuCopy, Chr$("&Copy",9,"Ctrl+C")
		invoke AppendMenu, hMenu, MF_POPUP, ghM3, Chr$("&Language")
		invoke AppendMenu, ghM3, MF_STRING, IdMenuEN, Chr$("&English")
		invoke AppendMenu, ghM3, MF_STRING, IdMenuRU, Chr$("&Russian")
		invoke AppendMenu, ghM3, MF_STRING, IdMenuAR, Chr$("&Arabic")
		invoke AppendMenu, ghM3, MF_STRING, IdMenuCH, Chr$("&Chinese")
		invoke SetMenu, hWnd, hMenu			; attach menu to main window
		endif
		; -------------------- create controls: buttons, edit window or listbox, static ---------- 
		mov hButFnt, rv(GetStockObject, ANSI_VAR_FONT)	; get a cute little font for the controls
		if MyChoice eq UseEdit
		  SubEdit PROTO:DWORD,:DWORD,:DWORD,:DWORD
		  if UseUnicode
			invoke CreateWindowExW, WS_EX_CLIENTEDGE, wChr$("edit"), NULL, 
				WS_CHILD or WS_VISIBLE or WS_BORDER\
				or ES_LEFT or ES_AUTOHSCROLL or ES_MULTILINE, 0, 0, 0, 0,
				hWnd, IdEdit, hInstance, NULL
			mov hEdit, eax							; we have created an edit window
	;		sm eax, WM_SETFONT, hButFnt, 1		; you may choose the small font here
			invoke SetWindowLongW, hEdit,		; we subclass the edit control
			GWL_WNDPROC, SubEdit
		  else
			invoke CreateWindowEx, WS_EX_CLIENTEDGE, Chr$("edit"), NULL, 
				WS_CHILD or WS_VISIBLE or WS_BORDER\
				or ES_LEFT or ES_AUTOHSCROLL or ES_MULTILINE, 0, 0, 0, 0,
				hWnd, IdEdit, hInstance, NULL
			mov hEdit, eax							; we have created an edit window
			; sm eax, WM_SETFONT, hButFnt, 1		; you may choose the small font here
			invoke SetWindowLong, hEdit,		; we subclass the edit control
			GWL_WNDPROC, SubEdit
		  endif
		mov opSubClass, eax					; the old pointer
		invoke SetFocus, hEdit					; give the focus to the edit window

		elseif MyChoice eq UseListbox
		invoke CreateWindowEx, WS_EX_CLIENTEDGE, Chr$("listbox"), NULL, 
			WS_CHILD or WS_VISIBLE or WS_BORDER	or WS_VSCROLL or \	;LBS_SORT or
			LBS_NOINTEGRALHEIGHT or LBS_USETABSTOPS or LBS_SORT,
			0, 0, 0, 0,
			hWnd, IdListbox, hInstance, NULL
		mov hListbox, eax						; we have created a listbox
		sm hListbox, WM_SETFONT, hButFnt, 1	; the small font looks better here
		sm hListbox, LB_DIR, DDL_READONLY, Chr$("*.asm")	; put something nice inside
		endif
		invoke CreateWindowEx, NULL, addr ClassButton, addr txButton1, 
			WS_CHILD or WS_VISIBLE or BS_DEFPUSHBUTTON, 0, 0, 0, 0,
			hWnd, IdButton1, hInstance, NULL
		mov hButton1, eax						; upper button created
		sm eax, WM_SETFONT, hButFnt, 1	; give it the small font
		if UseButton2
		invoke CreateWindowEx, NULL, addr ClassButton, addr txButton2,
			WS_CHILD or WS_VISIBLE or BS_DEFPUSHBUTTON, 0, 0, 0, 0,
			hWnd, IdButton2, hInstance, NULL
		mov hButton2, eax						; lower button created
		sm eax, WM_SETFONT, hButFnt, 1	; give it the small font
		endif
		invoke CreateWindowEx, NULL, addr ClassStatic, addr txStatic,
			WS_CHILD or WS_VISIBLE or ES_LEFT, 0, 0, 0, 0,
			hWnd, IdStatic, hInstance, NULL
		mov hStatic, eax						; static window under buttons created
		sm eax, WM_SETFONT, hButFnt, 1	; give it the small font
		ToolTips TTS_BALLOON				; give the user some hints
		if MyChoice eq UseEdit
			if UseUnicode
				ToolTips hEdit, 0 				; can be arabic, chinese, ...
			else
				ToolTips hEdit, "SHIFT IS PRESSED!!!"
			endif
		endif
		if MyChoice eq UseListbox
			ToolTips hListbox, "Select a file and click Open"
		endif
		if UseUnicode
			ToolTips hButton1, 0 				; can be arabic, chinese, ...
		else
			ToolTips hButton1, "Click on this button"
		endif
		if UseButton2
			ToolTips hButton2, "Say welcome"
		endif
		ToolTips end
		if UseUnicode
			mov eax, IdMenuEN				; start with English
			; mov eax, IdMenuRU				; start with Russian
			call SetLanguage
		endif

	CASE WM_COMMAND					; react here to menus and controls
		movzx eax, word ptr wParam			; the Ids are in the lowword of wParam
		switch eax
		if UseMenu
		case IdMenuNew						; feel free to call your own stuff here...
			sm hStatic, WM_SETTEXT, 0, Chr$("You clicked New")
		endif
		case IdMenuSave
			sm hStatic, WM_SETTEXT, 0,
			Chr$("You either clicked Save, or you pressed Control S")
		case IdMenuCopy
			sm hStatic, WM_SETTEXT, 0, Chr$("You clicked Copy")
		case IdButton1
			call Button1		; [url=+0]click here[/url] to jump to this procedure
		if UseButton2
		case IdButton2
			call Button2
		endif
		case IdEdit
			if UseUnicode
				wSetWin$ hStatic=wRes$(TheLang+1)
			else
				SetWin$ hStatic="Type some text"
			endif
		case IdEscape
;			MsgBox 0, Chr$("Sure to exit?"), addr txApp, MB_YESNO
;			.if eax==IDYES
				sm hWnd, WM_CLOSE, 0, 0	; Escape: exit without asking!
				return 0
;			.endif
		default
			if UseUnicode
				call SetLanguage	; language in eax
			else
				MsgBox 0, "Set Unicode to 1 and use a resource file", "Languages:"
			endif
		endsw

	CASE WM_NOTIFY
	mov edx, lParam					; Pointer to NOTIFY structure
	mov eax, [edx.NMHDR.code]		; message+8 = code
	.if eax==TTN_SHOW
		mov ebx, [edx.NMHDR.hwndFrom]	; tooltip window handle
		mov edx, [edx.NMHDR.idFrom]
		.if edx==hEdit
			invoke GetKeyState, VK_SHIFT
			.if sword ptr ax>=0
				invoke MoveWindow, ebx, -999, -999, 100, 100, 0
			.endif
			pop esi
			or eax, -1
			jmp Bye
		.endif
	.endif

	CASE WM_SIZE			; resize controls
		invoke GetClientRect, hWnd, addr rc
		push esi
		push ebx
		mov esi, rc.right
		sub esi, ButtonWidth	; editbox = window width minus button width
		mov ebx, rc.bottom
		sub ebx, 6
		invoke MoveWindow, hEdit, 3, 3, esi, ebx, 1
		add esi, 5				; buttons 5 pixels right of editbox
		mov ebx, rc.right
		sub ebx, esi
		sub ebx, 3
		invoke MoveWindow, hButton1, esi, 5, ebx, ButtonHeight, 1
		if UseButton2
		  invoke MoveWindow, hButton2, esi, 8+ButtonHeight, ebx, ButtonHeight, 1
		endif
		mov edx, rc.bottom
		sub edx, ButtonHeight*(1+UseButton2)+15
		invoke MoveWindow, hStatic, esi, 11+ButtonHeight*(1+UseButton2), ebx, edx, 1
		ifdef WmSizeHandler
			WmSizeHandler
		endif
		pop ebx
		pop esi

	ifdef WmPaintHandler
		CASE WM_PAINT
		WmPaintHandler
	endif

	ENDSW
	
	invoke DefWindowProc, hWnd, uMsg, wParam, lParam
Bye:	ret
WndProc endp

SetLanguage proc uses ebx
  .if eax>=IdMenuEN && eax<=IdMenuCH
	sub eax, IdMenuEN
	imul ebx, eax, 400
	push eax
	invoke CheckMenuItem, ghM3, ghM3PrevCk, MF_BYPOSITION or MF_UNCHECKED
	pop eax
	mov ghM3PrevCk, eax	; remember previously checked language
	invoke CheckMenuItem, ghM3, eax, MF_BYPOSITION or MF_CHECKED
	mov TheLang, ebx
	ToolTips hEdit, wRes$(ebx+1)	; type here
	ToolTips hButton1, wRes$(ebx+2)	; click on this button
	if UseButton2
		ToolTips hButton2, wRes$(ebx+2)	; click on this button
	endif
	wSetWin$ hStatic=wRes$(ebx+3)	; Welcome
  .endif
  ret
SetLanguage endp

Button1 proc
  if UseUnicode
	wSetWin$ hEdit=wRes$(TheLang+1)
	ToolTips hEdit, wRes$(TheLang+1)
  else
	MsgBox 0, Chr$("Thank you so much for pushing me!"), addr txApp, MB_OK
  endif
	ret
Button1 endp		; [url=+1]back to wm_command[/url]

if UseButton2
Button2 proc
  if MyChoice eq UseEdit
	if UseUnicode
	wSetWin$ hEdit=wRes$(TheLang+3)
	else
		SetWin$ hEdit=offset txStatic
	endif
  elseif MyChoice eq UseListbox
	call LbOpen
  endif
 ret
Button2 endp		; [url=+1]back to wm_command[/url]
endif

if MyChoice eq UseListbox	; ###--------------------------------------------------------------------------------###
LbOpen proc uses esi
LOCAL buffer [MAX_PATH]:BYTE
  lea esi, buffer
  sm hListbox, LB_GETCURSEL, 0, 0
  .if sdword ptr eax<0
	MsgBox 0, "No file selected", "Hi", MB_OK
  .else
	sm hListbox, LB_GETTEXT, eax, esi
	MsgBox 0, esi, "Open this file?", MB_YESNO
	.if eax==IDYES
		invoke ShellExecute, 0, 0, esi, 0, 0, SW_SHOWNORMAL
	.endif
  .endif
  ret
LbOpen endp
elseif MyChoice eq UseEdit	; ###--------------------------------------------------------------------------------###
SubEdit proc hwnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	SWITCH uMsg
;	CASE WM_KEYDOWN	; in general, no processing needed
	CASE WM_CHAR
	.if wParam==VK_RETURN				; user hit Enter
		xor eax, eax
		ret									; return 0 to suppress the insertion of a new line
	.endif
	CASE WM_KEYUP
	.if wParam==VK_F1
		MsgBox 0, Chr$("So you really expect help from hitting F1?", 10, "Go and find VK_F1 in the source!"), offset txApp, MB_OK
		invoke SetFocus, hEdit
	.elseif wParam==VK_RETURN			; comment out or replace with your own handler
		invoke SetWindowText, hEdit, chr$("RETURN inserts this text, try F1 now")
	.endif
	ENDSW
; subclassing finished, continue with default handler
  invoke CallWindowProc, opSubClass, hwnd, uMsg, wParam, lParam
  ret
SubEdit endp
endif			; ###--------------------------------------------------------------------------------###
end WinStart

RichMasm options
OPT_Tmp2Asm	1		; create an asm file for those who don't use RichMasm
OPT_Susy	Windows		; autodetect would vote for Console app, so set it explicitly

Resources must be put below the end label; when pressing F6, content between the two Rsrc lines will be written to [filename].rc
Any kind of resources are allowed here; use strings with e.g. Print Res$(101) or wPrint #1, wRes$(102) (w=wide, Unicode)
Note that in order to avoid bloated sections, strings should be incremented by 1, and start with indices that can be divided
by 16, as shown below (400/16=25, 800/16=50 etc). Note opt_icon will be ignored - what counts is the icon specified in the
resource file. You may delete these five lines once you don't need them any more.
